package x36paa_batoh_dp_4;

import java.awt.event.*;
import java.util.LinkedList;
import javax.swing.filechooser.*;
import java.io.*;
import layout.*;
import javax.swing.*;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
class FilesTester extends JFrame implements WindowListener, ActionListener, Runnable {

  private Thread timer=new Thread(this);
  private LinkedList<Instance> inputs=new LinkedList<Instance>();

  private int[][] sums; // algoritmus x (prum. rel, prum abs, max. rel, max. abs, exception)
  private int[][] results; // algoritmus x (prum. rel, prum abs, max. rel, max. abs, exception)
  private int count;
  private JLabel[][] labels;
  private JLabel filename=new JLabel();

  private JButton btn=new JButton("Zruit");
  private JCheckBox[] checkboxs;

  private boolean stop=false;

  public FilesTester() {
    init();
  }

  private void init() {
    results=new int[AlgorithmFactory.getCountOfAlgorithm()][5];
    sums=new int[AlgorithmFactory.getCountOfAlgorithm()][5];
    labels=new JLabel[AlgorithmFactory.getCountOfAlgorithm()][5];
    checkboxs=new JCheckBox[AlgorithmFactory.getCountOfAlgorithm()];
    for (int i=0;i<labels.length;i++)
      for (int j=0;j<labels[i].length;j++)
        labels[i][j]=new JLabel();
    load();
    GUIset();
    timer.start();
  }

  private void load() {
    FileSystemView sys=FileSystemView.getFileSystemView();
    File[] x=sys.getFiles(new File("data"),true);
    for (File f:x) {
      if (f.isFile()) {
        if (f.getName().indexOf("_r.")<0) {
          try {
            FileReader fr=new FileReader(f);
            BufferedReader br=new BufferedReader(fr);
            while (br.ready()) {
              String values[]=br.readLine().split(" ");
              Instance ins=new Instance();
              ins.id=Integer.parseInt(values[0]);
              int n=Integer.parseInt(values[1]);
              int maxWeigth=Integer.parseInt(values[2]);
              int j=3;
              java.util.List items=new LinkedList();
              for (int i=0; i<n; i++) {
                int weigth=Integer.parseInt(values[j++]);
                int price=Integer.parseInt(values[j++]);
                items.add(new Item(price, weigth, "Poloka "+i));
              }
              ins.filename=f.getName();
              ins.input=new Input(items, maxWeigth);
              inputs.add(ins);
            }
            br.close();
            fr.close();
          } catch (Exception e) {
            e.printStackTrace();
          }
        }
      }
    }
  }

  private void GUIset() {
    double size[][]=new double[2][];
    size[0]=new double[] {TableLayout.PREFERRED, TableLayout.FILL, TableLayout.PREFERRED, TableLayout.PREFERRED, TableLayout.PREFERRED, TableLayout.PREFERRED, TableLayout.PREFERRED};
    size[1]=new double[AlgorithmFactory.getCountOfAlgorithm()+3];
    for (int i=0;i<size[1].length;i++) size[1][i]=TableLayout.PREFERRED;
    size[1][size[1].length-1]=TableLayout.FILL;
    JPanel panel=new JPanel(new TableLayout(size));
    panel.add(new JLabel("<html><b>Soubor (id):</b></html>"),"1,0,F,F");
    panel.add(filename,"2,0,4,0");
    panel.add(new JLabel("<html><b> prm. rel. |</b></html>"),"2,1,F,F");
    panel.add(new JLabel("<html><b> prm. abs. |</b></html>"),"3,1,F,F");
    panel.add(new JLabel("<html><b> max. rel. |</b></html>"),"4,1,F,F");
    panel.add(new JLabel("<html><b> max. abs. |</b></html>"),"5,1,F,F");
    panel.add(new JLabel("<html><b> peteen </b></html>"),"6,1,F,F");
    for (int i=0;i<AlgorithmFactory.getCountOfAlgorithm();i++) {
      checkboxs[i]=new JCheckBox("",true);
      panel.add(checkboxs[i],"0,"+(i+2)+",F,F");
      panel.add(new JLabel("<html><b><i>"+AlgorithmFactory.getName(i)+"</i></b></html>"),"1,"+(i+2)+",F,F");
    }
    for (int i=0;i<labels.length;i++)
      for (int j=0;j<labels[i].length;j++)
        panel.add(labels[i][j],(j+2)+","+(i+2)+",F,F");
    setLabels();
    btn.addActionListener(this);
    this.addWindowListener(this);
    panel.add(btn,"5,"+(AlgorithmFactory.getCountOfAlgorithm()+2)+",F,F");
    this.getContentPane().add(panel);
    this.setTitle("Men na instancch v souborech adrese /data");
    this.pack();
    this.setLocationRelativeTo(null);
    this.setVisible(true);
  }

  private void setLabels() {
    for (int i=0;i<labels.length;i++)
      for (int j=0;j<labels[i].length;j++)
        labels[i][j].setText("<html><center>"+results[i][j]+"</center></html>");
    if (inputs.isEmpty()) {
      filename.setText("-.- (-)");
    } else {
      Instance ins=inputs.getFirst();
      filename.setText(ins.filename+" ("+ins.id+")");
    }
  }

  public void windowOpened(WindowEvent e) {
  }

  public void windowClosing(WindowEvent e) {
    stop=true;
    timer.stop();
    this.dispose();
  }

  public void windowClosed(WindowEvent e) {
  }

  public void windowIconified(WindowEvent e) {
  }

  public void windowDeiconified(WindowEvent e) {
  }

  public void windowActivated(WindowEvent e) {
  }

  public void windowDeactivated(WindowEvent e) {
  }

  public void run() {
    while (!stop) {
      try {
        setLabels();
        go();
        setLabels();
        inputs.removeFirst();
        if (inputs.isEmpty()) stop=true;
        timer.sleep(10);
      } catch (Exception e) {}
    }
  }

  private void go() {
    Instance ins=inputs.getFirst();
    Input input=ins.input;
    Output out=AlgorithmFactory.getMethod(9).calc(input);
    count++;
    int opt=out.getPrice();
    for (int i=0;i<AlgorithmFactory.getCountOfAlgorithm();i++) {
      if (checkboxs[i].isSelected()) {
        try {
          Output out2=AlgorithmFactory.getMethod(i).calc(input);
          int price=out2.getPrice();
          int abs=Math.abs(opt-price), rel=(100*abs)/opt;
          sums[i][0]+=rel;
          sums[i][1]+=abs;
          results[i][0]=sums[i][0]/count;
          results[i][1]=sums[i][1]/count;
          if (results[i][2]<rel)
            results[i][2]=rel;
          if (results[i][3]<abs)
            results[i][3]=abs;
        } catch (Exception e) {
          results[i][4]++;
        }
      }
    }
  }

  public void actionPerformed(ActionEvent e) {
    stop=true;
    timer.stop();
    this.dispose();
  }

  class Instance {
    public String filename;
    public int id;
    public Input input;
  }
}
