package x36paa_batoh_dp_4;

import java.awt.Color;
import java.util.*;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
class Measure4 implements MeasureInterface, Runnable {

  /**
   * type:
   * 0 : velikost instance
   * 1 : maximln hmotnost Wmax
   * 2 : maximln cena Cmax
   * 3 : pomr m
   * 4 : granularita
   *
   * measured:
   * 0 : cas
   * 1 : pocet operaci
   * 2 : odchylka
   */

  private int type,count,measured;
  private Graph graphs[]=new Graph[SelectedAlgorithmFactory.getCountOfAlgorithm()];
  Thread timer=new Thread(this);
  Graphs canvas;

  private final int[] paramsIntDefault       ={ 20,100,200,    0,   0};
  private final double[] paramsDoubleDefault ={  0,  0,  0,  0.5, 0.0};

  private final int[] paramsIntFrom          ={  4, 50, 50,    0,   0};
  private final double[] paramsDoubleFrom    ={  0,  0,  0,  0.1,-2.0};

  private final int[] stepInt=                {  2, 50, 50,    0,   0};
  private final double[] stepDouble=          {  0,  0,  0, 0.05, 0.1};

  private final int[] steps                  ={ 20, 10, 10,   20,  40};

  public Measure4(int type,int measured,int count) {
    this.type=type;
    this.count=count;
    this.measured=measured;
    synchronized (this) {
      for (int i=0; i<graphs.length; i++)
        graphs[i]=new Graph();
    }
    timer.start();
  }

  public String getTypeAsString() {
    switch (type) {
      case 0 : return "velikost instance";
      case 1 : return "maximln hmotnost Wmax";
      case 2 : return "maximln cena Cmax";
      case 3 : return "pomr m";
      case 4 : return "granularita";
      default:
        return null;
    }
  }

  public int getCountOfGraph() {
    return SelectedAlgorithmFactory.getCountOfAlgorithm();
  }

  public String getGraphName(int i) {
    return SelectedAlgorithmFactory.getName(i)+" (zvislost na "+getTypeAsString()+")";
  }

  public Color getGraphColor(int i) {
    return new Color[] {
        Color.RED,
        Color.BLUE,
        Color.GREEN,
        Color.YELLOW,

        Color.BLACK,
        Color.ORANGE,
        Color.PINK,
        Color.CYAN,

        Color.MAGENTA,
        Color.LIGHT_GRAY,
        Color.GRAY
    }[i];
  }

  public double getGraphMaxValue(int i) {
    synchronized (this) {
        double m=graphs[i].getMaxAvg();
        return m*1.1;
    }
  }

  public int getGraphValuesCount() {
    synchronized (this) {
      return graphs[0].size();
    }
  }

  public double getGraphValue(int graph, int position) {
    synchronized (this) {
      double b=getGraphMaxValue(graph);
      if (b==0) b=1;
      return graphs[graph].getAvg(position)/b;
    }
  }

  public void setCanvas(Graphs canvas) {
    this.canvas=canvas;
  }

  public void stop() {
    System.out.println(toString());
    if (timer==null) return;
    try {
      timer.stop();
    } catch(Exception e) {}
  }

  private double getParamDouble(int i, int step) {
    if (i!=type) return paramsDoubleDefault[i];
    return paramsDoubleFrom[i]+step*stepDouble[i];
  }

  private int getParamInt(int i, int step) {
    if (i!=type) return paramsIntDefault[i];
    return paramsIntFrom[i]+step*stepInt[i];
  }

  private String getParam(int i, int step) {
    switch (i) {
      case 0: case 1: case 2:
        return String.valueOf(getParamInt(i,step));
      case 3: case 4:
        return String.valueOf(getParamDouble(i,step));
      default:
        return null;
    }
  }

  public void run() {
    for (int i=0;i<count;i++) {
      for (int j=0;j<this.steps[type];j++) {
        List<Input> inputs=Generator.generate(1,getParamInt(0,j),getParamDouble(3,j),getParamInt(1,j),getParamInt(2,j),getParamDouble(4,j),1);
        Input input=inputs.get(0);
//      System.out.println(input.getMaxWeight()+">"+input+">");
        for (int k=0;k<SelectedAlgorithmFactory.getCountOfAlgorithm();k++) {
          Output output=SelectedAlgorithmFactory.getMethod(k).calc(input);
          synchronized (this) {
            switch (measured) {
              case 0:
                graphs[k].add(j, output.getTime(),getParam(type,j));
                break;
              case 1:
                graphs[k].add(j, output.getCountOfOperations(),getParam(type,j));
                break;
              case 2:
                Output outputOpt=AlgorithmFactory.getMethod(9).calc(input);
                double a=Math.abs(outputOpt.getPrice()-output.getPrice());
                double b=Math.max(outputOpt.getPrice(),output.getPrice());
                if (b>0) {
                  graphs[k].add(j, a/b,getParam(type,j));
                }
                break;
            }
          }
        }
      }
      if (canvas!=null) canvas.autoRepaint();
      try {
        timer.sleep(10);
      } catch (Exception e) {}
    }
    if (canvas!=null) canvas.repaint();
    System.out.println(toString());
  }

  public String toString() {
    StringBuffer out=new StringBuffer();
    out.append(graphs[0].getHead());
    int j=0;
    for (Graph graph : graphs) {
      out.append(getGraphName(j++)+"\t");
      for (int i=0; i<graph.size(); i++)
        out.append(graph.getAvg(i)+"\t");
      out.append("\n");
    }
    return out.toString();
  }
}
